<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>SerialInterface Class Reference</title>
<link href="xsens.css" rel="stylesheet" type="text/css"/>
</head><body>
<img class="logo" src="xsenslogo.jpg" alt="Xsens Logo" />
	<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="class_serial_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">SerialInterface Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>The low-level serial communication class.  
 <a href="class_serial_interface.html#details">More...</a></p>
<div class="dynheader">
Inheritance diagram for SerialInterface:</div>
<div class="dyncontent">
<div class="center"><img src="class_serial_interface__inherit__graph.png" border="0" usemap="#_serial_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="_serial_interface_inherit__map" id="_serial_interface_inherit__map">
<area shape="rect" id="node2" href="class_stream_interface.html" title="A stream interface. " alt="" coords="5,80,117,107"/>
<area shape="rect" id="node3" href="struct_io_interface.html" title="An abstract IO interface. " alt="" coords="21,5,101,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a1e52fefbfd802da3e838097061f6b512"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1e52fefbfd802da3e838097061f6b512"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a1e52fefbfd802da3e838097061f6b512">SerialInterface</a> ()</td></tr>
<tr class="memdesc:a1e52fefbfd802da3e838097061f6b512"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor, initializes all members to their default values. <br /></td></tr>
<tr class="separator:a1e52fefbfd802da3e838097061f6b512"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9054e926165962e4cf6b44b858075483"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9054e926165962e4cf6b44b858075483"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a9054e926165962e4cf6b44b858075483">~SerialInterface</a> ()</td></tr>
<tr class="memdesc:a9054e926165962e4cf6b44b858075483"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor, de-initializes, frees memory allocated for buffers, etc. <br /></td></tr>
<tr class="separator:a9054e926165962e4cf6b44b858075483"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70e928fd30e224db496182b3a20e04a0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a70e928fd30e224db496182b3a20e04a0"></a>
<a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a70e928fd30e224db496182b3a20e04a0">close</a> (void)</td></tr>
<tr class="memdesc:a70e928fd30e224db496182b3a20e04a0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the serial communication port. <br /></td></tr>
<tr class="separator:a70e928fd30e224db496182b3a20e04a0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a901f00e6b6a1f095530855a532d81c24"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a901f00e6b6a1f095530855a532d81c24"></a>
<a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a901f00e6b6a1f095530855a532d81c24">closeLive</a> (void)</td></tr>
<tr class="memdesc:a901f00e6b6a1f095530855a532d81c24"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the serial communication port. <br /></td></tr>
<tr class="separator:a901f00e6b6a1f095530855a532d81c24"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae53f1d6d64bbc94e47c0203d64bce2f1"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#ae53f1d6d64bbc94e47c0203d64bce2f1">flushData</a> (void)</td></tr>
<tr class="memdesc:ae53f1d6d64bbc94e47c0203d64bce2f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flush all data in the buffers to and from the device.  <a href="#ae53f1d6d64bbc94e47c0203d64bce2f1">More...</a><br /></td></tr>
<tr class="separator:ae53f1d6d64bbc94e47c0203d64bce2f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7730cb3cd3013186e77a4761ce7682ce"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7730cb3cd3013186e77a4761ce7682ce"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a7730cb3cd3013186e77a4761ce7682ce">isOpen</a> (void) const </td></tr>
<tr class="memdesc:a7730cb3cd3013186e77a4761ce7682ce"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether the communication port is open or not. <br /></td></tr>
<tr class="separator:a7730cb3cd3013186e77a4761ce7682ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a438cc68bd7dccdf526939350d57a9690"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a438cc68bd7dccdf526939350d57a9690"></a>
<a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a438cc68bd7dccdf526939350d57a9690">getLastResult</a> (void) const </td></tr>
<tr class="memdesc:a438cc68bd7dccdf526939350d57a9690"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the error code of the last operation. <br /></td></tr>
<tr class="separator:a438cc68bd7dccdf526939350d57a9690"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8347662088075a3dc32e6c7aca12e8c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#ae8347662088075a3dc32e6c7aca12e8c">writeData</a> (const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data, XsSize *written=0)</td></tr>
<tr class="memdesc:ae8347662088075a3dc32e6c7aca12e8c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the data contained in <em>data</em> to the device.  <a href="#ae8347662088075a3dc32e6c7aca12e8c">More...</a><br /></td></tr>
<tr class="separator:ae8347662088075a3dc32e6c7aca12e8c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec2eaf73e258e0bbc4b13418ccbc2978"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#aec2eaf73e258e0bbc4b13418ccbc2978">readData</a> (XsSize maxLength, <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data)</td></tr>
<tr class="memdesc:aec2eaf73e258e0bbc4b13418ccbc2978"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read data from the serial port and put it into the data buffer.  <a href="#aec2eaf73e258e0bbc4b13418ccbc2978">More...</a><br /></td></tr>
<tr class="separator:aec2eaf73e258e0bbc4b13418ccbc2978"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa354a286592ff1f36195d22ab7bd3275"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa354a286592ff1f36195d22ab7bd3275"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#aa354a286592ff1f36195d22ab7bd3275">cancelIo</a> (void) const </td></tr>
<tr class="memdesc:aa354a286592ff1f36195d22ab7bd3275"><td class="mdescLeft">&#160;</td><td class="mdescRight">Cancel any pending io requests. <br /></td></tr>
<tr class="separator:aa354a286592ff1f36195d22ab7bd3275"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1844b132ec921b271eeed468b1b6d092"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a1844b132ec921b271eeed468b1b6d092">escape</a> (<a class="el" href="group__enums.html#ga760018646ba5d22bd56b996d1c715424">XsControlLine</a> mask, <a class="el" href="group__enums.html#ga760018646ba5d22bd56b996d1c715424">XsControlLine</a> state)</td></tr>
<tr class="memdesc:a1844b132ec921b271eeed468b1b6d092"><td class="mdescLeft">&#160;</td><td class="mdescRight">Manipulate the Serial control lines.  <a href="#a1844b132ec921b271eeed468b1b6d092">More...</a><br /></td></tr>
<tr class="separator:a1844b132ec921b271eeed468b1b6d092"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb78f2ec8cc9c8f50e404d553d3cff37"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aeb78f2ec8cc9c8f50e404d553d3cff37"></a>
<a class="el" href="group__enums.html#ga2822b258045f067902cabca1a2f15eec">XsBaudRate</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#aeb78f2ec8cc9c8f50e404d553d3cff37">getBaudrate</a> (void) const </td></tr>
<tr class="memdesc:aeb78f2ec8cc9c8f50e404d553d3cff37"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the baudrate that is currently being used by the port. <br /></td></tr>
<tr class="separator:aeb78f2ec8cc9c8f50e404d553d3cff37"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab8cea24693959ca0f5851150cc134962"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab8cea24693959ca0f5851150cc134962"></a>
<a class="el" href="group__cinterface.html#ga8caac814a4ee656f1774ad23ccc5f16e">XsIoHandle</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#ab8cea24693959ca0f5851150cc134962">getHandle</a> (void) const </td></tr>
<tr class="memdesc:ab8cea24693959ca0f5851150cc134962"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the handle of the port. <br /></td></tr>
<tr class="separator:ab8cea24693959ca0f5851150cc134962"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6abb16f34bac12008f08b28f196c65a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af6abb16f34bac12008f08b28f196c65a"></a>
uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#af6abb16f34bac12008f08b28f196c65a">getPortNumber</a> (void) const </td></tr>
<tr class="memdesc:af6abb16f34bac12008f08b28f196c65a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve the port number that was last successfully opened. <br /></td></tr>
<tr class="separator:af6abb16f34bac12008f08b28f196c65a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f6e7a5fb2f1bb03efc085b27a539ed5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3f6e7a5fb2f1bb03efc085b27a539ed5"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a3f6e7a5fb2f1bb03efc085b27a539ed5">getPortName</a> (<a class="el" href="struct_xs_string.html">XsString</a> &amp;portname) const </td></tr>
<tr class="memdesc:a3f6e7a5fb2f1bb03efc085b27a539ed5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve the port name that was last successfully opened. <br /></td></tr>
<tr class="separator:a3f6e7a5fb2f1bb03efc085b27a539ed5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d2e3a6fedb9f40d1781c5039eadd9e4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2d2e3a6fedb9f40d1781c5039eadd9e4"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a2d2e3a6fedb9f40d1781c5039eadd9e4">getTimeout</a> (void) const </td></tr>
<tr class="memdesc:a2d2e3a6fedb9f40d1781c5039eadd9e4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current timeout value. <br /></td></tr>
<tr class="separator:a2d2e3a6fedb9f40d1781c5039eadd9e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a10cad30ffd713aa0e3316f3787073e48"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a10cad30ffd713aa0e3316f3787073e48">open</a> (const <a class="el" href="struct_xs_port_info.html">XsPortInfo</a> &amp;portInfo, uint32_t readBufSize=(XS_MAXMSGLEN *8), uint32_t writeBufSize=XS_MAXMSGLEN, <a class="el" href="struct_io_interface.html#a24230835a198e4af06866402ac41f22a">PortOptions</a> options=PO_XsensDefaults)</td></tr>
<tr class="memdesc:a10cad30ffd713aa0e3316f3787073e48"><td class="mdescLeft">&#160;</td><td class="mdescRight">Open a communication channel to the given port info.  <a href="#a10cad30ffd713aa0e3316f3787073e48">More...</a><br /></td></tr>
<tr class="separator:a10cad30ffd713aa0e3316f3787073e48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef4451a5710b1b3f30abf2bf24b07752"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#aef4451a5710b1b3f30abf2bf24b07752">setTimeout</a> (uint32_t ms)</td></tr>
<tr class="memdesc:aef4451a5710b1b3f30abf2bf24b07752"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the default timeout value to use in blocking operations.  <a href="#aef4451a5710b1b3f30abf2bf24b07752">More...</a><br /></td></tr>
<tr class="separator:aef4451a5710b1b3f30abf2bf24b07752"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6904ca085d855299772e2582f77e2dbe"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a6904ca085d855299772e2582f77e2dbe">waitForData</a> (XsSize maxLength, <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data)</td></tr>
<tr class="memdesc:a6904ca085d855299772e2582f77e2dbe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for data to arrive or a timeout to occur.  <a href="#a6904ca085d855299772e2582f77e2dbe">More...</a><br /></td></tr>
<tr class="separator:a6904ca085d855299772e2582f77e2dbe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_class_stream_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_class_stream_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="class_stream_interface.html">StreamInterface</a></td></tr>
<tr class="memitem:a747b4b4bc61925c6750ee35a54de30c5 inherit pub_methods_class_stream_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a747b4b4bc61925c6750ee35a54de30c5"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_stream_interface.html#a747b4b4bc61925c6750ee35a54de30c5">~StreamInterface</a> ()</td></tr>
<tr class="memdesc:a747b4b4bc61925c6750ee35a54de30c5 inherit pub_methods_class_stream_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy the stream interface. <br /></td></tr>
<tr class="separator:a747b4b4bc61925c6750ee35a54de30c5 inherit pub_methods_class_stream_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_struct_io_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_struct_io_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="struct_io_interface.html">IoInterface</a></td></tr>
<tr class="memitem:a738a8cb24aa12562b04c5067bd3d99b7 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a738a8cb24aa12562b04c5067bd3d99b7"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a738a8cb24aa12562b04c5067bd3d99b7">~IoInterface</a> ()</td></tr>
<tr class="memdesc:a738a8cb24aa12562b04c5067bd3d99b7 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:a738a8cb24aa12562b04c5067bd3d99b7 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4f4b165b49c75cb28bc1e4fffaf533d inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#ae4f4b165b49c75cb28bc1e4fffaf533d">appendData</a> (const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;bdata)</td></tr>
<tr class="memdesc:ae4f4b165b49c75cb28bc1e4fffaf533d inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write data to the end of the file.  <a href="#ae4f4b165b49c75cb28bc1e4fffaf533d">More...</a><br /></td></tr>
<tr class="separator:ae4f4b165b49c75cb28bc1e4fffaf533d inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a108ea51f7057bc5f762052777e7baa00 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a108ea51f7057bc5f762052777e7baa00">closeAndDelete</a> (void)</td></tr>
<tr class="memdesc:a108ea51f7057bc5f762052777e7baa00 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the file and delete it.  <a href="#a108ea51f7057bc5f762052777e7baa00">More...</a><br /></td></tr>
<tr class="separator:a108ea51f7057bc5f762052777e7baa00 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3e82060ef66d73b95b383f75867f3e0f inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a3e82060ef66d73b95b383f75867f3e0f">create</a> (const <a class="el" href="struct_xs_string.html">XsString</a> &amp;filename)</td></tr>
<tr class="memdesc:a3e82060ef66d73b95b383f75867f3e0f inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an empty file.  <a href="#a3e82060ef66d73b95b383f75867f3e0f">More...</a><br /></td></tr>
<tr class="separator:a3e82060ef66d73b95b383f75867f3e0f inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c4a40c13cdd1dbd36da1323f8d8236c inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a5c4a40c13cdd1dbd36da1323f8d8236c">deleteData</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> start, XsSize length)</td></tr>
<tr class="memdesc:a5c4a40c13cdd1dbd36da1323f8d8236c inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete the given data from the file.  <a href="#a5c4a40c13cdd1dbd36da1323f8d8236c">More...</a><br /></td></tr>
<tr class="separator:a5c4a40c13cdd1dbd36da1323f8d8236c inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6256ce5c2def7b6f6961cedd8199e35e inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a6256ce5c2def7b6f6961cedd8199e35e">find</a> (const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;needleV, <a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> &amp;pos)</td></tr>
<tr class="memdesc:a6256ce5c2def7b6f6961cedd8199e35e inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Find a string of bytes in the file.  <a href="#a6256ce5c2def7b6f6961cedd8199e35e">More...</a><br /></td></tr>
<tr class="separator:a6256ce5c2def7b6f6961cedd8199e35e inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7acf94e2070b556290d969a324e8b93 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#af7acf94e2070b556290d969a324e8b93">getFileSize</a> (void) const </td></tr>
<tr class="memdesc:af7acf94e2070b556290d969a324e8b93 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the size of the file.  <a href="#af7acf94e2070b556290d969a324e8b93">More...</a><br /></td></tr>
<tr class="separator:af7acf94e2070b556290d969a324e8b93 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7bbdfbb5caad826f6e6d81a73940fd0d inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a7bbdfbb5caad826f6e6d81a73940fd0d">getName</a> (<a class="el" href="struct_xs_string.html">XsString</a> &amp;filename) const </td></tr>
<tr class="memdesc:a7bbdfbb5caad826f6e6d81a73940fd0d inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve the filename that was last successfully opened.  <a href="#a7bbdfbb5caad826f6e6d81a73940fd0d">More...</a><br /></td></tr>
<tr class="separator:a7bbdfbb5caad826f6e6d81a73940fd0d inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a396d5028db152401dd83cfe8f0b6977e inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a396d5028db152401dd83cfe8f0b6977e">getReadPosition</a> (void) const </td></tr>
<tr class="memdesc:a396d5028db152401dd83cfe8f0b6977e inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current read position.  <a href="#a396d5028db152401dd83cfe8f0b6977e">More...</a><br /></td></tr>
<tr class="separator:a396d5028db152401dd83cfe8f0b6977e inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6ce051fb4db1dbace80bb0545b9cd343 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a6ce051fb4db1dbace80bb0545b9cd343">getWritePosition</a> (void) const </td></tr>
<tr class="memdesc:a6ce051fb4db1dbace80bb0545b9cd343 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current write position.  <a href="#a6ce051fb4db1dbace80bb0545b9cd343">More...</a><br /></td></tr>
<tr class="separator:a6ce051fb4db1dbace80bb0545b9cd343 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0d5e78791e017e06f8beaa6561bd844 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#ad0d5e78791e017e06f8beaa6561bd844">insertData</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> start, const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data)</td></tr>
<tr class="memdesc:ad0d5e78791e017e06f8beaa6561bd844 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insert the given data into the file.  <a href="#ad0d5e78791e017e06f8beaa6561bd844">More...</a><br /></td></tr>
<tr class="separator:ad0d5e78791e017e06f8beaa6561bd844 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a905628de220b542bdfbf3692a55de428 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a905628de220b542bdfbf3692a55de428">isReadOnly</a> (void) const </td></tr>
<tr class="memdesc:a905628de220b542bdfbf3692a55de428 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether the file is read-only or not.  <a href="#a905628de220b542bdfbf3692a55de428">More...</a><br /></td></tr>
<tr class="separator:a905628de220b542bdfbf3692a55de428 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a041ed4c0878f91fa8c41a72aa7b3e802 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a041ed4c0878f91fa8c41a72aa7b3e802">open</a> (const <a class="el" href="struct_xs_string.html">XsString</a> &amp;filename, bool createNew, bool readOnly)</td></tr>
<tr class="memdesc:a041ed4c0878f91fa8c41a72aa7b3e802 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Open a file.  <a href="#a041ed4c0878f91fa8c41a72aa7b3e802">More...</a><br /></td></tr>
<tr class="separator:a041ed4c0878f91fa8c41a72aa7b3e802 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e75151a26492f0fa9666edabc09d817 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a6e75151a26492f0fa9666edabc09d817">setReadPosition</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> pos)</td></tr>
<tr class="memdesc:a6e75151a26492f0fa9666edabc09d817 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the new absolute read position.  <a href="#a6e75151a26492f0fa9666edabc09d817">More...</a><br /></td></tr>
<tr class="separator:a6e75151a26492f0fa9666edabc09d817 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a115109da1f9f05a36222f00cd569cd52 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a115109da1f9f05a36222f00cd569cd52">setWritePosition</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> pos=-1)</td></tr>
<tr class="memdesc:a115109da1f9f05a36222f00cd569cd52 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the new absolute write position.  <a href="#a115109da1f9f05a36222f00cd569cd52">More...</a><br /></td></tr>
<tr class="separator:a115109da1f9f05a36222f00cd569cd52 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:ad36bafbd5446dadd31d48dbb0692c245"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad36bafbd5446dadd31d48dbb0692c245"></a>
<a class="el" href="group__enums.html#ga2822b258045f067902cabca1a2f15eec">XsBaudRate</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#ad36bafbd5446dadd31d48dbb0692c245">m_baudrate</a></td></tr>
<tr class="memdesc:ad36bafbd5446dadd31d48dbb0692c245"><td class="mdescLeft">&#160;</td><td class="mdescRight">The baudrate that was last set to be used by the port. <br /></td></tr>
<tr class="separator:ad36bafbd5446dadd31d48dbb0692c245"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9e2a266784885259dc03646806a8c9c4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9e2a266784885259dc03646806a8c9c4"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a9e2a266784885259dc03646806a8c9c4">m_endTime</a></td></tr>
<tr class="memdesc:a9e2a266784885259dc03646806a8c9c4"><td class="mdescLeft">&#160;</td><td class="mdescRight">The time at which an operation will end in ms, used by several functions. <br /></td></tr>
<tr class="separator:a9e2a266784885259dc03646806a8c9c4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1aa68fe0a7472a809624d93cdbac5ef"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae1aa68fe0a7472a809624d93cdbac5ef"></a>
<a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#ae1aa68fe0a7472a809624d93cdbac5ef">m_lastResult</a></td></tr>
<tr class="memdesc:ae1aa68fe0a7472a809624d93cdbac5ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">The last result of an operation. <br /></td></tr>
<tr class="separator:ae1aa68fe0a7472a809624d93cdbac5ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a960075ede31e8ba85c74219e862faa79"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a960075ede31e8ba85c74219e862faa79"></a>
uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a960075ede31e8ba85c74219e862faa79">m_port</a></td></tr>
<tr class="memdesc:a960075ede31e8ba85c74219e862faa79"><td class="mdescLeft">&#160;</td><td class="mdescRight">The opened COM port nr. <br /></td></tr>
<tr class="separator:a960075ede31e8ba85c74219e862faa79"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a538bf768266b442f8c98f083af4d6250"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a538bf768266b442f8c98f083af4d6250"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a538bf768266b442f8c98f083af4d6250">m_portname</a> [32]</td></tr>
<tr class="memdesc:a538bf768266b442f8c98f083af4d6250"><td class="mdescLeft">&#160;</td><td class="mdescRight">The name of the open serial port. <br /></td></tr>
<tr class="separator:a538bf768266b442f8c98f083af4d6250"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1224eb8876eabb887a03e96163df160"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#af1224eb8876eabb887a03e96163df160">m_timeout</a></td></tr>
<tr class="separator:af1224eb8876eabb887a03e96163df160"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60d28f793f93febcf67e68305ceee351"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a60d28f793f93febcf67e68305ceee351"></a>
termios&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a60d28f793f93febcf67e68305ceee351">m_commState</a></td></tr>
<tr class="memdesc:a60d28f793f93febcf67e68305ceee351"><td class="mdescLeft">&#160;</td><td class="mdescRight">Stored settings about the serial port. <br /></td></tr>
<tr class="separator:a60d28f793f93febcf67e68305ceee351"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a41dd143df945a161bd51c1d46b4d5bd4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a41dd143df945a161bd51c1d46b4d5bd4"></a>
int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_serial_interface.html#a41dd143df945a161bd51c1d46b4d5bd4">m_handle</a></td></tr>
<tr class="memdesc:a41dd143df945a161bd51c1d46b4d5bd4"><td class="mdescLeft">&#160;</td><td class="mdescRight">The serial port handle, also indicates if the port is open or not. <br /></td></tr>
<tr class="separator:a41dd143df945a161bd51c1d46b4d5bd4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_struct_io_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_types_struct_io_interface')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="struct_io_interface.html">IoInterface</a></td></tr>
<tr class="memitem:a24230835a198e4af06866402ac41f22a inherit pub_types_struct_io_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a24230835a198e4af06866402ac41f22a"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a24230835a198e4af06866402ac41f22a">PortOptions</a> { <br />
&#160;&#160;<b>PO_NoFlowControl</b> = 0, 
<b>PO_RtsCtsFlowControl</b> = (1 &lt;&lt; 0), 
<b>PO_DtrDsrFlowControl</b> = (1 &lt;&lt; 1), 
<b>PO_XonXoffFlowControl</b> = (1 &lt;&lt; 2), 
<br />
&#160;&#160;<b>PO_OneStopBit</b> = 0, 
<b>PO_TwoStopBits</b> = (1 &lt;&lt; 3), 
<b>PO_XsensDefaults</b> = (PO_NoFlowControl|PO_TwoStopBits)
<br />
 }<tr class="memdesc:a24230835a198e4af06866402ac41f22a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Options for flow control and stopbits which must be used when opening a port. <br /></td></tr>
</td></tr>
<tr class="separator:a24230835a198e4af06866402ac41f22a inherit pub_types_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_class_stream_interface"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_class_stream_interface')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="class_stream_interface.html">StreamInterface</a></td></tr>
<tr class="memitem:ab40993736e0f3c472c19293355a26389 inherit pro_methods_class_stream_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab40993736e0f3c472c19293355a26389"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_stream_interface.html#ab40993736e0f3c472c19293355a26389">StreamInterface</a> ()</td></tr>
<tr class="memdesc:ab40993736e0f3c472c19293355a26389 inherit pro_methods_class_stream_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a stream interface. <br /></td></tr>
<tr class="separator:ab40993736e0f3c472c19293355a26389 inherit pro_methods_class_stream_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_struct_io_interface"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_struct_io_interface')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="struct_io_interface.html">IoInterface</a></td></tr>
<tr class="memitem:a0a4be67f0496efa12593cc69a802d784 inherit pro_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0a4be67f0496efa12593cc69a802d784"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a0a4be67f0496efa12593cc69a802d784">IoInterface</a> ()</td></tr>
<tr class="memdesc:a0a4be67f0496efa12593cc69a802d784 inherit pro_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor. <br /></td></tr>
<tr class="separator:a0a4be67f0496efa12593cc69a802d784 inherit pro_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>The low-level serial communication class. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a1844b132ec921b271eeed468b1b6d092"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> SerialInterface::escape </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__enums.html#ga760018646ba5d22bd56b996d1c715424">XsControlLine</a>&#160;</td>
          <td class="paramname"><em>mask</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__enums.html#ga760018646ba5d22bd56b996d1c715424">XsControlLine</a>&#160;</td>
          <td class="paramname"><em>state</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Manipulate the Serial control lines. </p>
<p>The function manipulates the serial control lines that are indicated by the mask parameter. Note that only the DTR and RTS lines can be set by win32. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">mask</td><td>Indicates which lines are to be manipulated and which should be left alone. </td></tr>
    <tr><td class="paramname">state</td><td>Contains the new state of the control lines. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the function succeeded </dd></dl>

</div>
</div>
<a class="anchor" id="ae53f1d6d64bbc94e47c0203d64bce2f1"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> SerialInterface::flushData </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Flush all data in the buffers to and from the device. </p>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was flushed successfully </dd></dl>
<dl class="section note"><dt>Note</dt><dd>This function tries to send and receive any remaining data immediately and does not return until the buffers are empty. </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#aac5cc2c3707b24cc15f9ab15914448fa">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a10cad30ffd713aa0e3316f3787073e48"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> SerialInterface::open </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_port_info.html">XsPortInfo</a> &amp;&#160;</td>
          <td class="paramname"><em>portInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>readBufSize</em> = <code>(XS_MAXMSGLEN*8)</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>writeBufSize</em> = <code>XS_MAXMSGLEN</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_io_interface.html#a24230835a198e4af06866402ac41f22a">PortOptions</a>&#160;</td>
          <td class="paramname"><em>options</em> = <code>PO_XsensDefaults</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Open a communication channel to the given port info. </p>
<p>If the baudrate in <em>portInfo</em> is set to XBR_Invalid, the baud rate is automatically detected if possible. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">portInfo</td><td>The details of the port that should be opened. Depending on the type of interface, parts of this parameter may be ignored. </td></tr>
    <tr><td class="paramname">readBufSize</td><td>The size of the read buffer in bytes (if appliccable to the device) </td></tr>
    <tr><td class="paramname">writeBufSize</td><td>The size of the write buffer in bytes (if appliccable to the device) </td></tr>
    <tr><td class="paramname">options</td><td>The options to enable (flow control, stop bits) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the device was opened successfully </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a567804b45988f0111362d600babd4627">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="aec2eaf73e258e0bbc4b13418ccbc2978"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> SerialInterface::readData </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>maxLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Read data from the serial port and put it into the data buffer. </p>
<p>This function reads up to <em>maxLength</em> bytes from the port (non-blocking) and puts it into the <em>data</em> buffer. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxLength</td><td>The maximum amount of data read. </td></tr>
    <tr><td class="paramname">data</td><td>The buffer that will store the received data. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if no error occurred. It can be that no data is available and XRV_OK will be returned. Check data.size() for the number of bytes that were read. </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#a33818cfaffd39a7e1382e465d26efc0a">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="aef4451a5710b1b3f30abf2bf24b07752"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> SerialInterface::setTimeout </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>ms</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the default timeout value to use in blocking operations. </p>
<p>This function sets the value of m_timeout. There is no infinity value. The value 0 means that all blocking operations now become polling (non-blocking) operations. If the value is set to or from 0, the low-level serial port settings may be changed in addition to the m_timeout value. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ms</td><td>The new timeout in milliseconds </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the function succeeded </dd></dl>

<p>Implements <a class="el" href="class_stream_interface.html#ac787d6f9451b39e5315cc19993249861">StreamInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a6904ca085d855299772e2582f77e2dbe"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> SerialInterface::waitForData </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>maxLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Wait for data to arrive or a timeout to occur. </p>
<p>The function waits until <code>maxLength</code> data is available or until a timeout occurs. The function returns success if data is available or XsResultValue::TIMEOUT if a timeout occurred. A timeout value of 0 indicates that the default timeout stored in the class should be used. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxLength</td><td>The maximum number of bytes to read before returning </td></tr>
    <tr><td class="paramname">data</td><td>The buffer to put the read data in. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if <em>maxLength</em> bytes were read, XRV_TIMEOUT if less was read, XRV_TIMEOUTNODATA if nothing was read </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#aa9763f4a8ea90af8abeab4ada6f36502">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="ae8347662088075a3dc32e6c7aca12e8c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> SerialInterface::writeData </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsSize *&#160;</td>
          <td class="paramname"><em>written</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Write the data contained in <em>data</em> to the device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>The data to write to the device. </td></tr>
    <tr><td class="paramname">written</td><td>An optional XsSize value that will receive the number of bytes that were actually written. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was written successfully </dd></dl>
<dl class="section note"><dt>Note</dt><dd>The default timeout is respected in this operation. </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#a8e8f067dac101d2ef49080956ad53970">IoInterface</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="af1224eb8876eabb887a03e96163df160"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t SerialInterface::m_timeout</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>The default timeout value to use during blocking operations. A value of 0 means that all operations become non-blocking. </p>

</div>
</div>
</div><!-- contents -->

<div class="tabs">&nbsp;</div>
<hr size="1" />
<address style="text-align: right;">
<small>Generated on Wed May 17 2017 for Xsens by <a href="http://www.doxygen.org/index.html">Doxygen</a> 1.8.11</small>
</address>
</body>
</html>
